static char *cvs_id =" $Id: bm_map.c,v 1.1.1.1 2002/01/03 14:52:03 berar Exp $ ";
/*  bm_map.c : image princeton (Winview ) et autres    */
/*  jfberar   berar@esrf.fr */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <errno.h>
#include <ctype.h>
/*-----------------------------------------------------------*/
#include "prg_def.h"

#include "xy_def.h"
#include "bm_def.h"

#include "7c_def.h"

/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
void hkl_map (char *name, char *path, IMAGE *img  )
{   long i, x, y;
    int ok;
    FILE *f_out;
    char *c, b[200], *cr;
/*    double e;*/
    INT32 *val;

    if ((val=img->data) == NULL) V_ERROR("no data to write");
    if ( orig_x == 0.0) orig_x = image.x_size/2.0;
    if ( orig_y == 0.0) orig_y = image.y_size/2.0;
    
    if (path) 
    {   strcpy (b, path);    
        c = strrchr(b,'/');
        if ( !c || c - b != strlen(b)-1 ) strcat(b, "/");
        }
    else b[0]=0;
    c = strrchr(img->name,'/');
    if ( c )  c++; else c = img->name;
    strcat (b, c);
    c = strrchr(b, '/');
    if ( !c ) c = b;
    c = strrchr(c, '.');
    if ( c ) *c = 0;
    strcat (b, ".map");
    
    printf(" UB %s\n", spec_ub == 1 ? "spec_mode(2Pi)" : "not_spec");
    for (i = 0; i < 9; i++) 
	printf(" UB[%d]= %12.6lf %s", i, mat_ub.t[i], i%3==2?"\n":" ");
    inv_mat( & mat_inv_ub, &mat_ub );
    f_out = fopen(b, "w");
    printf(" printing ascii map in %s\n", b);
    for (i=0; i<image.size; i++) 
    {   y = i / image.x_size;
        x = i % image.x_size;
        goniometer.pos.ry=(x*image.x_obind+image.x_omin - orig_x)*scale_xx
                         +(y*image.y_obind+image.y_omin - orig_y)*scale_xy;
        goniometer.pos.rz=(x*image.x_obind+image.x_omin - orig_x)*scale_yx
                         +(y*image.y_obind+image.y_omin - orig_y)*scale_yy;
        get_hkl();
        ok = 1;
/*	if (ehkl)
	{    e = ahkl * hkl.hkl.v[0] + bhkl * hkl.hkl.v[1] + bhkl * hkl.hkl.v[2] - dhkl;
	     if (fabs(e) > ehkl ) ok = 0;
	     }
*/	if (ok != 0) 
	{   fprintf(f_out, " %7.4lf %7.4lf %7.4lf %10ld\n",
                hkl.hkl.v[0], hkl.hkl.v[1], hkl.hkl.v[2],val[i]); 
            if ( (x == 0 || x == (image.x_size-1)/2 || x == image.x_size-1) 
               &&  (y == 0 || y == (image.y_size-1)/2 || y == image.y_size-1) )
	     printf(" %4d*%4d R(%7.2f,%7.2f,%7.2f)  %8.4lf %8.4lf %8.4lf %10ld\n",
               x, y, goniometer.pos.rx, goniometer.pos.ry, goniometer.pos.rz,
               hkl.hkl.v[0], hkl.hkl.v[1], hkl.hkl.v[2],val[i]);
            }
       }     
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/

