/* $Id: prg_def.h,v 1.2 2002/07/19 07:37:30 berar Exp $ */
/* prg_def.h */
#ifndef  PRG_DEF_H
#define  PRG_DEF_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

extern char* prg_name;
extern int log_mode;
/*-----------------------------------------------------------*/
void prg_basename(char *buffer, char *src_name);
void prg_pathname(char *buffer, char *src_name);
void prg_outname(char *buffer, char *name, char *def_name, char *def_ext, char *def_path);
char * prg_get_name(char *tag, char * buffer);
void prg_inifile( void parameter(FILE *f_ini));
int prg_initag(char *b, char **tag, char **arg);
int prg_inistr(char *tag, char *arg, char *key, char **s);
int prg_iniint(char *tag, char *arg, char *key, int *d);
int prg_iniflt(char *tag, char *arg, char *key, float *d);
int prg_inidbln(char *tag, char *arg, char *key, double *d, int n);
/*-----------------------------------------------------------*/
int prg_printf( char *format, ...);
int prg_fprintf( FILE *f, char *format, ...);
int prg_fflush( FILE *f);
/*-----------------------------------------------------------*/
#ifdef __WIN32__
#define PRG_EXIT  if (mode==USE_ARGS) {puts("\nwaiting keyboard"); getchar();}
#else
#define PRG_EXIT
#endif
/*-----------------------------------------------------------*/
char *str_alloc(char *model);
void *prg_alloc(char *file, char *name, long size, int zeroset);
void *prg_realloc(char *file, char *name, void *ptr, long size);
/*-----------------------------------------------------------*/
#include <stdarg.h>
#define  STDARG
#define V_ERROR(a)   v_error( __FILE__ , a)
void v_error (char *lib_name, char *format, ... );
/*-----------------------------------------------------------*/
#endif        /*  PRG_DEF_H sentry */
